package aop4csmCL;
import java.io.*; 
import java.net.*;


/**
 * @author Afef Mdhaffar
 *
 */

public aspect MonitorClient{



long TreqC;
long TrespC;
long Tresp;
int SuccReq = 0;
int AllReq = 0;
//T=2 minutes
long T = 120000;
long Tfin=0;
long Tdeb ;
int i =0;

//Pointcut1
pointcut requestClient(): execution(* org.apache.axis.AxisEngine.init(..));
before(): requestClient() {
	Tdeb = System.currentTimeMillis();

	try{
	
		//Save AllReq
		File fichier = new File("saveAllReq.txt");
		fichier.createNewFile();
		FileReader fr = new FileReader("saveAllReq.txt");
		BufferedReader br = new BufferedReader(fr);
		String temp = br.readLine();
		PrintWriter printwriter = new PrintWriter(new FileOutputStream("saveAllReq.txt"));
		if(temp == null)
		{
			printwriter.println("1");
		}
		else{
			AllReq = Integer.parseInt(temp.trim());
			br.close();
			//Calculate the number of all invocations
			AllReq++;
			//save this number in a file
			//Future versions will include RTM processing for these values
			printwriter.println(""+ AllReq);
		}
		printwriter.close();
	} 
	catch(IOException ioe){
		System.out.println("erreur: " + ioe);
	}
	//Save t1
	TreqC = System.currentTimeMillis();
	
}


//Pointcut4
pointcut responseClient(): execution(* org.apache.axis.client.Stub.extractAttachments(..));
after(): responseClient() {
	try{
		//Save SuccReq
		File fichierSuccReq = new File("SuccReq.txt");
		fichierSuccReq.createNewFile();
		FileReader frSuccReq = new FileReader("SuccReq.txt");
		BufferedReader brSuccReq = new BufferedReader(frSuccReq);
		String tempSuccReq = brSuccReq.readLine();
		PrintWriter printwriterSuccReq = new PrintWriter(new FileOutputStream("SuccReq.txt"));
		if(tempSuccReq == null) {
			printwriterSuccReq.println("1");
		}
		else{
			SuccReq = Integer.parseInt(tempSuccReq.trim());
			brSuccReq.close();
			//Increment the number of Successful requests
			SuccReq++;
			//Save the number of Successful requests in a file 
			printwriterSuccReq.println(""+ SuccReq);
		}
		printwriterSuccReq.close();
		
		//Save Time Debut to start timer (Period T = 2 minutes)
		File TimeDebut = new File("saveTimeDebut.txt");
		TimeDebut.createNewFile();
		FileReader frTimeDebut = new FileReader("saveTimeDebut.txt");
		BufferedReader brTimeDebut = new BufferedReader(frTimeDebut);
		String TimeDebtemp = brTimeDebut.readLine();
		PrintWriter Tdebwriter = new PrintWriter(new FileOutputStream("saveTimeDebut.txt"));
		if(TimeDebtemp==null){
			//Save Time Start 
			String s = ""+ Tdeb;
			Tdebwriter.println(s);
			Tdebwriter.close();
		}
		else{
			//Compute Time end	
			Tfin = Long.parseLong(TimeDebtemp.trim())+T;
			if(Tfin <= Tdeb){
			System.out.println("Period End");
			float succ = Float.parseFloat(tempSuccReq);
			
			//Compute Throughput
			float Throughput = succ/120;
			FileReader fr = new FileReader("saveAllReq.txt");
			BufferedReader br = new BufferedReader(fr);
			String temp = br.readLine();
			//Compute Availability
			float all = Float.parseFloat(temp);
			float Availability = succ/all;

			System.out.println("Throughput = "+Throughput);
			System.out.println("Availability = "+Availability);
			//Period End == RAS 
			Tdebwriter.println(""+ Tdeb);
			PrintWriter allwriter = new PrintWriter(new FileOutputStream("saveAllReq.txt"));
			PrintWriter succwriter = new PrintWriter(new FileOutputStream("SuccReq.txt"));
			allwriter.println("1");
			succwriter.println("1");
		}
		else
		{
			
			Tdebwriter.println(TimeDebtemp);
		}
		
		Tdebwriter.close();

			
	}

	
}
 catch(IOException ioe){System.out.println("erreur fadda: " + ioe);}

	TrespC = System.currentTimeMillis();
	
	//Compute Response time
	Tresp = TrespC - TreqC;
	System.out.println("Response Time = "+ Tresp);
	//SuccReq++;
	}
}



	
	

